from optparse import OptionParser

import pyglet

from cocos.director import director

from shrooms import cfg
from shrooms.scenes import StartScreen


if __name__ == "__main__":
    parser = OptionParser()
    parser.add_option(
        '--no-music',
        dest='is_music',
        action="store_false",
        default=True,
        help='Play music and sound FX in game'
    )

    (options, args) = parser.parse_args()

    director_kwargs = {
        'audio_backend': 'sdl',
        'resizable': False,
        'fullscreen': False,
        'width': cfg.W,
        'height': cfg.H,
        'caption': 'PyWeek 17: Sane Mushroom Picking'
    }
    if not options.is_music:
        director_kwargs['audio'] = None
    director.init(**director_kwargs)

    # Must be after director.init
    from shrooms.sounds import sounds
    if options.is_music:
        sounds.init()

    cursor = pyglet.window.ImageMouseCursor(
        pyglet.image.load('data/cursor.png'), 12, 12
    )
    director.window.set_mouse_cursor(cursor)
    director.run(StartScreen())
