from cocos.euclid import Vector2


W = 800
H = 600
HALF_W = W // 2
HALF_H = H // 2
CENTER = Vector2(HALF_W, HALF_H)

MAX_DISTANCE = 600.0

MOON_R = 128

DEFAULT_T = 1.0

PL_ANCHOR = (27.0, 3.0)
PL_ANCHOR_R = (31.0, 3.0)
PL_SPEED = 80.0
PL_SHAPE_RADIUS = 10.0

HAND_POS = Vector2(0.0, 41.0)
HAND_ANCHOR = Vector2(12.0, 17.0)
HAND_ANCHOR_R = Vector2(35.0, 17.0)
HAND_GUN_DISTANCE = 27.073972741361768

SHR_ANCHOR = (33.5, 10.0)
SHR_INIT_SCALE = 0.2
SHR_SCALE_MIN = 0.4
SHR_SCALE_MAX = 0.8
SHR_SCALE_SPEED_MIN = 0.3
SHR_SCALE_SPEED_MAX = 0.6
SHR_SHAPE_RADIUS = 24.0
SHR_FLY_DELAY = 0.1
SHR_FLY_SPEED = 150
SHR_MAX_COUNT = 20
SHR_GEN_TIMEOUT_MIN = 0.2
SHR_GEN_TIMEOUT_MAX = 2.0
SHR_GEN_RAND_DIST_INDEXES = [-2, -1, 0, 1, 2]
SHR_GEN_DISTANCE_FROM_PL = 60.0
SHR_GEN_THRESHOLD_MAIN = 0.4
SHR_GEN_THRESHOLD_REL = 0.25
SHR_GEN_DISTANCE_REL = 10.0
SHR_REQUIRED_MIN = 30
SHR_REQUIRED_MAX = 60

CUT_POS_DELTA = 7.0
CUT_SCALE_DELTA = 0.1
CUT_FADE_OUT_TIMEOUT = 0.3

EXPLOSION_INIT_DELAY = 0.4
EXPLOSION_FADE_OUT_TIME = 1.5

BULLET_SPEED = 0.8
BULLET_SPEED_RANDOM = 0.3
BULLET_COUNT = 5
BULLET_DIR_RANDOM = 20

SUN_INIT_T = 0.4
SUN_POS = Vector2(100, 100)
SUN_ROT = 45
SUN_CYCLE_T = 120.0
SUN_A = 150
SUN_B = 200

EARTH_INIT_T = 0.7
EARTH_POS = Vector2(400, 450)
EARTH_ROT = -67
EARTH_CYCLE_T = 75.0
EARTH_A = 250
EARTH_B = 180

STAR_COUNT = 25
STAR_MAX_ATTEMPT = 15
STAR_MIN_DISTANCE = 80.0
STAR_BLINK_SCALE = 1.5
STAR_BLINK_T = 0.3
STAR_BLINK_DELAY = 10.0

PADDING = 15

BACK_COLOR = (124, 139, 133, 148)

END_EXPLANATION_N = 3
END_EXPLANATION = '''INFORMATION:
    By the way, end game condition is totally random.
    Achievements too.

    Sorry, I had no time to create something meaningful.'''
END_ACHIEVEMENTS = [
    'Sniper',
    'Fast',
    'Slow',
    'Snake',
    'Berseker',
    'Nature lover',
]
END_CONG_TEXT_TEMPLATE = '''Congratulations!!!
A winner is You!!!

Mushrooms: {0}
Achievement: "{1}"'''

START_TEXT = ('Relax. Everything is just fine. You are on the Moon. '
              'Just go pick up some mushrooms.')

START_CONTROLS = '''
A, LEFT - to move Counter-Clock-Wise
D, RIGHT - to move Clock-Wise
Mouse Click - to shoot'''
